/*
    lkpatch - a Linux Kernel Patcher

    Copyright 1999, 2000 Theo Nolte <nolte@post.rwth-aachen.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
*/

typedef struct buf_t {
  int magic,fd,frozen;
  char*p,*file;
  int sz,pos;
} BUF;

struct buf_t *newbuf(void) ; /* return a new buffer */
void delbuf(struct buf_t *bp) ;
void addbuf(struct buf_t *bp,char*buf,int n) ;
void bufdump(struct buf_t *bp) ;
char*bufptr(struct buf_t *bp) ;
char*buffile(struct buf_t *bp) ;
int buflen(struct buf_t *bp) ;

/*------------------------------------------------------------------*/

typedef struct {
  char*url;
  char*host,*vhost;
  char*path;
  u32 ip;
  int port;
  long q;
} UBUFE;

typedef struct {
  int magic;
  UBUFE*a;
  int sz,n;
} UBUF;

UBUF*ubnew(void) ; /* make an ubuf with sz entries */
void ubdel(UBUF*ub) ; /* delete ubuf */
void ubdelel(UBUF*ub,int nd) ; /* delete entry nd */
UBUFE*ubel(UBUF*ub,int i) ;
void ubaddurl(UBUF*ub,char*s) ; /* append entry */
void ubaddent(UBUF*ub,UBUFE*ube) ;
char*ubgeturl(UBUF*ub,int n) ; /* rtn entry nr n */
int ublen(UBUF*ub) ; /* return length */
void ubsortbyport(UBUF*ub) ;
void ubsortbyq(UBUF*ub) ;
UBUFE*ubgeta(UBUF*ub) ;
int ubexist(UBUF*ub,u32 ip,int port) ;
void ubdeldups(UBUF*ub) ; /* del entries with same ip/port */
void ubtrunc(UBUF*ub, int n) ;
