/*
    lkpatch - a Linux Kernel Patcher

    Copyright 1999, 2000 Theo Nolte <nolte@post.rwth-aachen.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
*/

#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <unistd.h>
#include <netdb.h>
#include <netinet/in.h>
#include <signal.h>
#include <assert.h>

#include "lkpatch.h"

char*connerr;

static int ALM;

void sigalm(int s) {
  ALM=1;
/*  fprintf(stderr,"ALARM\n");*/
}

long conntm(u32 ip,int port,int tmlim) { /* return connection time to host */
 struct sockaddr_in ds;
 int sfd;
 long rv;
 struct timeval t1,t2;
 struct timezone tz;
 struct sigaction sa;
 sigset_t sigset;
/*printf("measure(%s,%d)\n",host,port);*/
  sa.sa_handler=sigalm;
  sigemptyset(&sigset);
  sa.sa_mask=sigset;
  sa.sa_flags=0;
  memset((char*)&ds,0,sizeof(ds));
  ds.sin_family=AF_INET;
  ds.sin_addr.s_addr=ip;
  ds.sin_port=htons(port);
  if((sfd=socket(AF_INET,SOCK_STREAM,0))<0) {
    error(1,errno,"error opening socket");
  }
  if(sigaction(SIGALRM,&sa,0)==-1) {
    error(1,errno,"error installing signal handler");
  }
  alarm(tmlim);
  if(gettimeofday(&t1,&tz)==-1) error(1,errno,"gettimeofday error");
  if(connect(sfd,(struct sockaddr*)&ds,sizeof(ds))<0) {
    close(sfd);
/*printf("connect error (host %s)\n",host);*/
    connerr=strerror(errno);
    if(ALM) { connerr="timed out"; ALM=0; }
    return(0);
  }
  if(gettimeofday(&t2,&tz)==-1) error(1,errno,"gettimeofday error");
  alarm(0);
  close(sfd);
  rv=1000000*(t2.tv_sec-t1.tv_sec)+(t2.tv_usec-t1.tv_usec);
#if 0
{u32 a=ntohl(ip);
printf("connect(%03d.%03d.%03d.%03d: %2d, %2d): %9ld usec\n",
(a>>24)&0xff,(a>>16)&0xff,(a>>8)&0xff,a&0xff,port,tmlim,rv);
}
#endif
  return(rv);
}
